

      program driver
      implicit real*8(a-h,o-z)
      include "mpif.h"
c
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c
c     
      parameter(m=25,n=25,nproc=1)
c
c     
      parameter(nitmx=100000,tol=1.e-8)
c
c     
      parameter(np=n/nproc+1)
c
c     
      dimension aloc(0:m+1,0:np+1),adebug(0:m+1,0:np+1)
      dimension jbeg(0:nproc-1),jend(0:nproc-1)
c
c     
      integer istat(MPI_STATUS_SIZE)
      real*8 t0,t1,t2           !note: result from MPI_WTIME() is real*8
c
c     
      character*80 filename
      logical lconverged
      external lconverged
c-----|---------------------------------------------------------------|
c     
      call MPI_INIT(ierr)
      t0=MPI_WTIME()
      call MPI_COMM_RANK(MPI_COMM_WORLD,myid,ierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD,numprocs,ierr)
      MY_MPI_REAL=MPI_DOUBLE_PRECISION
c$$$      MY_MPI_REAL=MPI_REAL
      if(numprocs.ne.nproc)then !thats not what we compiled for
         write(*,*)'difference in no of procs: ',numprocs,nproc
         goto 111
      endif
c
c     
      write(*,*)'hello. I am ',myid,' out of ',numprocs
c
c     
      call MPE_DECOMP1D_all(n,nproc,jbeg,jend,'_')
c
c
c     
      call assign(aloc,1,m,jbeg(myid),jend(myid),m,n,myid,nproc,'b',2)
c
c     
      call exchange_ghostline1(aloc,m,jbeg(myid),jend(myid),
     $     myid,nproc,MPI_COMM_WORLD,MY_MPI_REAL)
c
      filename='init.dat'
      call write2d_p(aloc,adebug,m,n,jbeg(myid),jend(myid),jbeg,jend,
     $     MPI_COMM_WORLD,MY_MPI_REAL,myid,nproc,filename)
c
      t1=MPI_WTIME()
c     
      do 100 iter=1,nitmx       !this is the main iteration loop
c     
         call jacobi_step(aloc,adebug,1,m,jbeg(myid),jend(myid),m,n,
     $        myid,nproc,diffl,valmxl) 
c     
         if(lconverged(diffl,valmxl,tol,iter,myid,nproc,
     $        MPI_COMM_WORLD,MY_MPI_REAL))goto 110
c     
         call exchange_ghostline1(aloc,m,jbeg(myid),jend(myid),
     $        myid,nproc,MPI_COMM_WORLD,MY_MPI_REAL)
c
 100  continue
 110  continue
c
      t2=MPI_WTIME()
      if(myid.eq.0)then
         write(*,*)'time for iterative loop: ',t2-t1,' sec ',
     $        '(unit 55)'
         write(55,*)m,n,nproc,t2-t1,iter
      endif
c
c     
      filename='numeric.dat'
      call write2d_p(aloc,adebug,m,n,jbeg(myid),jend(myid),jbeg,jend,
     $     MPI_COMM_WORLD,MY_MPI_REAL,myid,nproc,filename)
c
c     
      call assign(adebug,1,m,jbeg(myid),jend(myid),m,n,myid,nproc,
     $     'a',2)
      call check_array(aloc,adebug,1,m,jbeg(myid),jend(myid),
     $     myid,nproc,MPI_COMM_WORLD,MY_MPI_REAL,'a')
c
c     
      filename='analytic.dat'
      call write2d_p(adebug,aloc,m,n,jbeg(myid),jend(myid),jbeg,jend,
     $     MPI_COMM_WORLD,MY_MPI_REAL,myid,nproc,filename)
c     
c     
c     
 111  write(*,*)myid,' about to finalize MPI'
      call MPI_FINALIZE(ierr)
      write(*,*)'bye. ',myid      
c     
      stop
      end
c-----|---------------------------------------------------------------|
      subroutine MPE_DECOMP1D_all(n,numprocs,s,e,chi)
c
c     
c     
c     
c     
c     
c     
c     
c     
c     
c
      integer n, numprocs, myid, s(0:numprocs-1), e(0:numprocs-1)
      integer nlocal
      integer deficit
      character*1 chi
c     
c     
      do myid=0,numprocs-1
         nlocal  = n / numprocs
         s(myid) = myid * nlocal + 1
         deficit = mod(n,numprocs)
         s(myid) = s(myid) + min(myid,deficit)
         if (myid .lt. deficit) then
            nlocal = nlocal + 1
         endif
         e(myid) = s(myid) + nlocal - 1
         if (e(myid) .gt. n .or. myid .eq. numprocs-1) e(myid) = n
         if(chi.eq.'p')then
c     
            s(myid) = s(myid) + 1
            e(myid) = e(myid) + 1
         endif
      enddo
      return
      end
c----+----------------------------------------------------------------|
      subroutine assign(a,if,il,jf,jl,m,n,my_rank,nproc,cghost,itype)
      implicit real*8(a-h,o-z)
c
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c
      dimension a(if-1:il+1,jf-1:jl+1)
      character*1 cghost
c----+----------------------------------------------------------------|
      pi=4.*atan(1.)
      if(cghost.eq.'g'.or.cghost.eq.'a')then !fill ghost-cells in 'j' with data
         jff=jf-1
         jll=jl+1
      else                      !set j-ghosts to zero
         jff=jf
         jll=jl
         do i=if-1,il+1
            a(i,jf-1)=0.0
            a(i,jl+1)=0.0
         enddo
      endif
      if(itype.eq.1)then
c     
         do j=jff,jll
            do i=if-1,il+1
               a(i,j)=float(i*j)
            enddo
         enddo
      elseif(itype.eq.2)then
c     
c     
c     
         do j=jf-1,jl+1
            do i=if-1,il+1
               a(i,j)=0.0       !all to zero
            enddo
         enddo
         if(cghost.ne.'b')then  !fill interior (and ghosts in case of 'g'/'a')
            do j=jff,jll
               yy=float(j)/float(n+1)
               do i=if-1,il+1
                  xx=float(i)/float(m+1)
                  a(i,j)=solution(xx,yy,itype)
               enddo
            enddo
         endif
c     
         do j=jff,jll
            yy=float(j)/float(n+1)
            i=if-1
            xx=float(i)/float(m+1)
            a(i,j)=solution(xx,yy,itype)
            i=il+1
            xx=float(i)/float(m+1)
            a(i,j)=solution(xx,yy,itype)
         enddo
c     
         if(my_rank.eq.0)then   !i am the first processor
            j=jf-1
            yy=float(j)/float(n+1)
            do i=if-1,il+1
               xx=float(i)/float(m+1)
               a(i,j)=solution(xx,yy,itype)
            enddo
         endif
         if(my_rank.eq.nproc-1)then !i am the last proc.
            j=jl+1
            yy=float(j)/float(n+1)
            do i=if-1,il+1
               xx=float(i)/float(m+1)
               a(i,j)=solution(xx,yy,itype)
            enddo
         endif
      else
         write(*,*)'assign: this type not implemented: ',itype
         stop
      endif
c
      return
      end subroutine assign
c----+----------------------------------------------------------------|
      subroutine check_array(a,aref,if,il,jf,jl,my_rank,nproc,mpi_comm,
     $     irealtype,cghost)
      implicit real*8(a-h,o-z)
      include "mpif.h"
c
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c
      dimension a(if-1:il+1,jf-1:jl+1),aref(if-1:il+1,jf-1:jl+1)
      character*1 cghost
c----+----------------------------------------------------------------|
      if(cghost.eq.'g')then     !check _only_ the ghost cells
                                !end-procs: don't check boundaries
         if(my_rank.gt.0)then
            jff=jf-1
         else
            jff=jf
         endif
         if(my_rank.lt.nproc-1)then
            jll=jl+1
         else
            jll=jl
         endif
         jskip=jll-jff
      elseif(cghost.eq.'a')then !check all of the array
                                !end-procs: don't check boundaries
         if(my_rank.gt.0)then
            jff=jf-1
         else
            jff=jf
         endif
         if(my_rank.lt.nproc-1)then
            jll=jl+1
         else
            jll=jl
         endif
         jskip=1
      else                      !check only the "interior"
         jff=jf
         jll=jl
         jskip=1
      endif
c
      errmx=0.
      valmx=0.
      do j=jff,jll,jskip
         do i=if-1,il+1
            err=abs(a(i,j)-aref(i,j))
            errmx=max(errmx,err)
            valmx=max(valmx,aref(i,j))
         enddo
      enddo
c
      CALL MPI_REDUCE(errmx,errmxg,1,irealtype,
     &     MPI_MAX,0,mpi_comm,ierr)
      CALL MPI_REDUCE(valmx,valmxg,1,irealtype,
     &     MPI_MAX,0,mpi_comm,ierr)
      
      if(my_rank.eq.0)write(*,*)'maximum relative error: ',
     $     errmxg/valmxg,errmxg,valmxg
c
      return
      end subroutine check_array
c----+----------------------------------------------------------------|
      subroutine write_array(a,if,il,jf,jl,my_rank,iunit)
      implicit real*8(a-h,o-z)
c
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c
      dimension a(if-1:il+1,jf-1:jl+1)
c----+----------------------------------------------------------------|
      write(iunit,110)my_rank
      do i=if-1,il+1
         do j=jf-1,jl+1
            write(iunit,111)my_rank,i,j,a(i,j)
         enddo
      enddo
c
 110  format('write_array: myid=',i5)
 111  format(1x,3(i5,1x),1(e15.8,1x))
c
      return
      end subroutine write_array
c----+----------------------------------------------------------------|
      real*8 function solution(x,y,itype)
      implicit real*8(a-h,o-z)
      pi=4.*atan(1.)
c
      if(itype.eq.2)then
         solution=sin(pi*x)*exp(-pi*y)
      else
         write(*,*)'solution: this type not implmented! ',itype
         stop
      endif
c     
      return
      end function solution
c----+----------------------------------------------------------------|
      subroutine jacobi_step(a,tmp,if,il,jf,jl,m,n,my_rank,nproc,
     $     diff,valmx)
      implicit real*8(a-h,o-z)
c
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c
      dimension a(if-1:il+1,jf-1:jl+1),tmp(if-1:il+1,jf-1:jl+1)
c----+----------------------------------------------------------------|
      pi=4.*atan(1.)
c
      diff=0.0
      valmx=0.0
      do j=jf,jl
         do i=if,il
            tmp(i,j)=(a(i,j+1)+a(i+1,j)+a(i-1,j)+a(i,j-1))*.25
            diff=max(diff,abs(tmp(i,j)-a(i,j)))
            valmx=max(valmx,abs(tmp(i,j)))
         enddo
      enddo
      do j=jf,jl
         do i=if,il
            a(i,j)=tmp(i,j)
         enddo
      enddo
c
      return
      end subroutine jacobi_step
c----+----------------------------------------------------------------|
      logical function lconverged(diffl,valmxl,tol,iter,
     $     my_rank,nproc,mpi_comm,irealtype)
      implicit real*8(a-h,o-z)
      include "mpif.h"
c     
      lconverged=.false.
c     
      CALL MPI_Allreduce(diffl,diffg,1,irealtype,
     &     MPI_MAX,mpi_comm,ierr)
      CALL MPI_Allreduce(valmxl,valmxg,1,irealtype,
     &     MPI_MAX,mpi_comm,ierr)
c     
      diffl=diffl/valmxg
      diffg=diffg/valmxg
      if(diffg.le.tol)then
         lconverged=.true.
         write(*,*)my_rank,' we have converged!',diffl,diffg,iter
      endif
      diffl=diffg
c     
      return
      end function lconverged
c---- +----------------------------------------------------------------|
      subroutine write2d_p(a,tmp,m,n,jf,jl,jbeg,jend,
     $     icomm,irealtype,my_rank,nproc,filename)
      implicit real*8(a-h,o-z)
      include "mpif.h"
      integer istat(MPI_STATUS_SIZE)
      dimension a(0:m+1,jf-1:jl+1),tmp(0:m+1,jf-1:jl+1)
      dimension jbeg(0:nproc-1),jend(0:nproc-1)
      character*80 filename
      parameter(iout=30)
c-----|---------------------------------------------------------------|
      nline=m+2
      if(my_rank.eq.0)then
         write(*,*)'writing ascii to ',filename
         open(iout,file=filename)
         jll=jl
         if(nproc.eq.1)jll=jll+1
         call do_write2d(a,m,jf,jl,jf-1,jll,iout)
         do iproc=1,nproc-1
            call MPI_RECV(tmp,(jend(iproc)-jbeg(iproc)+3)*nline,
     $           irealtype,iproc,1,icomm,istat,ierr)
            jll=jend(iproc)
            if(iproc.eq.nproc-1)jll=jend(iproc)+1
            call do_write2d(tmp,m,jbeg(iproc),jend(iproc),jbeg(iproc),
     $           jll,iout)
         enddo
         close(iout)
      else
         call MPI_SEND(a,(jend(my_rank)-jbeg(my_rank)+3)*nline,
     $        irealtype,0,1,icomm,istat,ierr) !includes ghosts!!!
      endif
c
      call MPI_BARRIER(icomm,ierr)
c
      return
      end subroutine write2d_p
c----+----------------------------------------------------------------|
      subroutine do_write2d(a,m,jf,jl,jff,jll,iunit)
      implicit real*8(a-h,o-z)
      dimension a(0:m+1,jf-1:jl+1)
c
      do j=jff,jll
         do i=0,m+1
            write(iunit,111)i,j,a(i,j)
         enddo
         write(iunit,112)
      enddo
c     
 111  format(1x,2(i5,1x),1(e15.8,1x))
 112  format(' ')
c
      return
      end subroutine do_write2d
c----+----------------------------------------------------------------|
